module ParserFrontEnd
  include ParserCommon
    #   c.define_tag 'language_bar' do
    #     @site.in_use_locales.map{ |locale|
    #       lang = I18nVariable.first(:conditions => {:key => locale})[locale]
    #       if I18n.locale.to_s.eql?(locale)
    #         lang
    #       else
    #         "<a href='?locale=#{locale}'>#{lang}</a>"
    #       end
    #     }.join(' | ')
    #   end
    #   c.define_tag 'link' do |tag|
    #     item = Item.first(:conditions => { :full_name => tag.attr['name'] })
    #     ret = ''
    #     ret << "<a href='#{tag.attr['name']}'>"
    #     ret << item.i18n_variable[I18n.locale]
    #     ret << '</a>'
    #   end
    # end

  require 'nokogiri'

  def parse_page_noko(page, id = nil,params)
    body = Nokogiri::HTML(page.design.layout.body)
    parse_menu(body, page)
    public_r_tags = parse_contents(body, page, id,params[:preview])
    parse_images(body, page)
    parse_footer(body, page, true)

    public_r_tags.each do |tag|
      send("parse_#{tag}s", body, page,id)
    end

    body.to_html
  end

  # page_contents
  def parse_contents(body, page, id,preview = false)
    public_r_tags = []
    body.css('.page_content').each do |content|
      ret = ''
      if (content["main"] == "true" && !page.module_app.nil?)
        ret << "<div id='appfrontend' class='dymanic_load' path='/panel/#{page.module_app.key}/front_end/#{page.app_frontend_url}"
        ret << "/#{id}" if id
        ret << "?inner=true&page_id=#{page.id}"
        # ret << "&category_id=#{page.category}" if page[:category]
        ret << "&category_id=#{params[:category_id]}" if !params[:category_id].blank?
        ret << "&tag_id=#{params[:tag_id]}" if !params[:tag_id].blank?
        ret << "&preview=true" if preview.eql?('true')
        ret << "'></div>"
      else
        part = page.page_parts.detect{ |p| p.name.to_s == content['name'].to_s } rescue nil
        case part.kind
        when 'text'
          ret << part.i18n_variable[I18n.locale] rescue ''
        when 'module_widget'
          # if part[:category]
          #   ret << "<div class='dymanic_load' path='/panel/#{part.module_app.key}/widget/#{part.widget_path}?inner=true&category_id=#{part[:category]}'></div>"
          # else
          #   ret << "<div class='dymanic_load' path='/panel/#{part.module_app.key}/widget/#{part.widget_path}?inner=true'></div>"
          # end
          if !params[:category_id].blank?
            ret << "<div class='dymanic_load' path='/panel/#{part.module_app.key}/widget/#{part.widget_path}?inner=true&category_id=#{params[:category_id]}'></div>"
          elsif !params[:tag_id].blank?
            ret << "<div class='dymanic_load' path='/panel/#{part.module_app.key}/widget/#{part.widget_path}?inner=true&tag_id=#{params[:tag_id]}'></div>"
          else
            ret << "<div class='dymanic_load' path='/panel/#{part.module_app.key}/widget/#{part.widget_path}?inner=true'></div>"
          end
        when 'public_r_tag'
          ret << "<r:#{part.public_r_tag} id='#{part.public_r_tag_object_id}'/>"
          public_r_tags << part.public_r_tag
        else
            ''
        end if part
      end
      scope = "<#{content.name}"
      content.attributes.each_pair do |key, value|
        scope << " #{key}='#{value}'"
      end
      scope << ">#{ret}</#{content.name}>"
      fragment = Nokogiri::HTML::DocumentFragment.new(body, scope)
      content.swap(fragment)
    end
    public_r_tags.uniq
  end
  
end
